if 0 {
	set test {{1 3} 0 5 1 1 3 -2}
	foreach {poss refstart refend complement varstart varend vardiff} $test break
}

proc conv_regcoordinates {poss refstart refend complement {vstart -1} {vend -1} {vdiff 0}} {
# putsvars poss refstart refend complement vstart vend vdiff
	set result {}
	if {$vend == -1} {set vend [expr {$vstart + 1}]}
	if {$vdiff > 0} {incr vstart}
	if {!$complement} {
		foreach {s e} $poss {
			if {!$vdiff || $s < $vstart} {
				set ns [expr {$s - $refstart + 1}]
			} elseif {$s < $vend} {
				set ns [expr {$vstart - $refstart + 1}]
			} else {
				set ns [expr {$s - $refstart + $vdiff + 1}]
			}
			if {!$vdiff || $e < $vstart} {
				set ne [expr {$e - $refstart}]
			} elseif {$e < $vend} {
				set ne [expr {$vstart - $refstart}]
			} else {
				set ne [expr {$e - $refstart + $vdiff}]
			}
			if {$ns <= $ne} {
				lappend result $ns $ne
			} else {
				lappend result $ns $ns
			}
		}
	} else {
		foreach {s e} $poss {
			if {!$vdiff || $s >= $vend} {
				set ns [expr {$refend - $s}]
			} elseif {$s >= $vstart} {
				set ns [expr {$refend - $vend}]
			} else {
				set ns [expr {$refend - $s + $vdiff}]
			}
			if {!$vdiff || $e >= $vend} {
				set ne [expr {$refend - $e + 1}]
			} elseif {$e >= $vstart} {
				set ne [expr {$refend - $vend + 1}]
			} else {
				set ne [expr {$refend - $e + 1 + $vdiff}]
			}
			if {$ns >= $ne} {
				lappend result $ns $ne
			} else {
				lappend result $ns $ns
			}
		}
	}
	return $result
}

proc coords_fill {s e complement} {
	if {$e == $s} {
		return $e
	} elseif {$e < $s} {
		set temp $s ; set s $e ; set e $temp
	}
	set result {}
	for {set i $s} {$i <= $e} {incr i} {lappend result $i}
	return $result
}

proc draw_structure {out seq struct geneobjVar vartype varstart varend vardiff changes} {
# putsvars out seq struct geneobjVar varstart varend vardiff changes
	upvar $geneobjVar a

	set complement $a(complement)
	set refseqstart $a(refseqstart)
	set refseqend $a(refseqend)
	# show structural changes
	set convchanges {}
	set refstart 0
	set refend $a(refseqsize)
	foreach {s e} [conv_regcoordinates $changes $refstart $refend $complement $varstart $varend $vardiff] {
		lappend convchanges {*}[coords_fill $s $e $complement]
	}
	# show variant
	set vartype [string trim $vartype]
	if {$vartype eq "snp"} {
		set reg [list $varstart $varend]
	} else {
		# pick one extra for inserts/del so insert is shown
		set reg [list [expr {$varstart - 1}] [expr {$varend + 1}]]
	}
	foreach {svar evar} [conv_regcoordinates $reg $refstart $refend $complement $varstart $varend $vardiff] break
	# putsvars svar evar
	set varbases [coords_fill $svar $evar $complement]
	set convchanges [list_lremove $convchanges $varbases]
	# show annot regions
	# cyan/blue/green/orange
	array set pallettea {arm 66FFFF mature 1f75ff loop 00CC00 seed FF9933}
	# blue/magenta/yellow/orange
	array set pallettea {arm 33CCFF mature 9900FF loop FFFF00 seed FF9933}
	# colorbrewer colorblind proof? (blues/greens)
	array set pallettea {arm a6cee3 mature b2df8a loop 1f78b4 seed 33a02c}
	# colorbrewer colorblind proof? (blues/yelow-orange-red)
	array set pallettea {arm abd9e9 loop 2c7bb6 mature FFFF33 seed fdae61}
	# colorbrewer colorblind proof? (purples/oranges)
	array set pallettea {arm b2abd2 loop 5e3c99 mature fdb863 seed e66101 var ff0000}
	# ggplot colorblind friendly (blues/oranges) (http://www.cookbook-r.com/Graphs/Colors_%28ggplot2%29/#a-colorblind-friendly-palettehttp://www.cookbook-r.com/Graphs/Colors_%28ggplot2%29/#a-colorblind-friendly-palette)
	array set pallettea {arm 56B4E9 loop 0072B2 mature CC79A7 seed E69F00 var FF1414}
	array set stylea [subst {
		arm5p fill=#$pallettea(arm),outline=#$pallettea(arm),radius=20;
		arm3p fill=#$pallettea(arm),outline=#$pallettea(arm),radius=20;
		mature5p fill=#$pallettea(mature),outline=#$pallettea(mature),radius=20;
		mature3p fill=#$pallettea(mature),outline=#$pallettea(mature),radius=20;
		loop fill=#$pallettea(loop),outline=#$pallettea(loop),radius=20;
		seed fill=#$pallettea(seed),outline=#$pallettea(seed),radius=25;
	}]
	set gvarstart [expr {$varstart + $refseqstart}]
	set gvarend [expr {$varend + $refseqstart}]
	set highlightregion ""
	set refstart $refseqstart
	set refend $refseqend
	list_foreach {annot aref adir abegin aend} $a(annotlist) {
		if {[regexp {mature[35]p} $annot temp]} {set annot $temp}
		if {![info exists stylea($annot)]} continue
		if {$vardiff != 0 && $abegin >= $gvarstart && $aend <= $gvarend} continue
		set reg [conv_regcoordinates [list $abegin $aend] $refstart $refend $complement $gvarstart $gvarend $vardiff]
		if {[lindex $reg 0] != [lindex $reg 1]} {
			if {![regexp ^mature $annot]} {
				append highlightregion "[join $reg -]:$stylea($annot)"
			} else {
				foreach {s e} $reg break
				if {$s > $e} {
					append highlightregion "${e}-${e}:$stylea($annot)"
					append highlightregion "[expr {$e+1}]-[expr {$e+6}]:$stylea(seed)"
					append highlightregion "[expr {$e+7}]-${s}:$stylea($annot)"
				} else {
					append highlightregion "${s}-${s}:$stylea($annot)"
					append highlightregion "[expr {$s+1}]-[expr {$s+6}]:$stylea(seed)"
					append highlightregion "[expr {$s+7}]-${e}:$stylea($annot)"
				}
			}
		}
	}
	set VarnaVersion [file normalize $::appdir/extern/varna/VARNAv3-9.jar]
	set VarnaCMD fr.orsay.lri.varna.applications.VARNAcmd
	set cmd [list \
		exec [java] -cp $VarnaVersion $VarnaCMD \
		-algorithm naview \
		-basesStyle1 "fill=#[get pallettea(var) ff0000]" \
		-basesStyle2 "label=#fdfdfd,fill=#010101,outline=#fdfdfd" \
		-highlightRegion $highlightregion \
		-autoInteriorLoops true \
		-autoTerminalLoops true \
		-sequenceDBN $seq \
		-structureDBN $struct \
		-resolution 3.0	\
		-flat true \
		-warning False \
		-applyBasesStyle1on [join $varbases ,]]
	if {[llength $convchanges]} {
		lappend cmd -applyBasesStyle2on [join $convchanges ,]
	}
	# png output
	set pngcmd $cmd
	lappend pngcmd -o $out\.png
	if {[catch $pngcmd msg]} {
		puts $msg
	}
	# svg output
	set svgcmd $cmd
	lappend svgcmd -o ${out}-temp.svg
	if {[catch $svgcmd msg]} {
		puts $msg
	}
	set c [file_read ${out}-temp.svg]
	regsub {(<svg [^>]+)>} $c {\1 onload="fixDimensions();">
<script type="text/javascript">
 <![CDATA[
     function fixDimensions() {
         // fix bug with Opera, Firefox and Chrome when scaling. Surprisingly,
         // only IE9 works as expected.
         var svgEl = document.documentElement;
         var bBox = svgEl.getBBox();
         if (svgEl.width.baseVal.valueAsString == "100%")
                 svgEl.width.baseVal.valueAsString = bBox.width + "px";
         if (svgEl.height.baseVal.valueAsString == "100%")
                 svgEl.height.baseVal.valueAsString = bBox.height + "px";
     }
 ]]>
</script>
} c
	file_write ${out}.svg $c
	return $out\.svg
}

