proc rnafold {} {
	if {$::tcl_platform(platform) eq "windows"} {
		set rnafold [file normalize $::appdir/extern/RNAfold-win/RNAfold.exe]
	} else {
		set rnafold [file normalize $::appdir/extern/RNAfold/RNAfold]
	}
	return $rnafold
}

proc getstructure {sequence {dotfile {}}} {
	set keeppwd [pwd]
	cd [tempdir]
	if {$sequence eq ""} {
		return [dict create \
			DeltaG,Cen ? struct,Cen {} \
			DeltaG,MEA ? struct,MEA {} \
			DeltaG,MFE ? struct,MFE {} \
			mfefreq ?]
	}
	catch {
		exec [rnafold] --noPS --MEA -p -d2 << $sequence
	} msg
	set out [split $msg \n]
	set result 0
	incr result [regexp { ([0-9]+\.*.*); .*} [lindex $out 5] match MFEfreq]
	incr result [regexp { *(.*) [MEAd]+=.*} [lindex $out 3 1] match CenDeltaG]
	incr result [regexp { *(.*) [MEAd]+=.*} [lindex $out 4 1] match MEADeltaG]
	incr result [regexp {.*\( *(.*)\)} [lindex $out 1] match MFEDeltaG]
	if {$dotfile ne ""} {
		puts stderr "-----------Creating $dotfile"
		catch {file rename -force dot.ps $dotfile}
	}
	if {$result != 4} {
		error "There was some error in output of rnafold:\n$msg"
	}
	cd $keeppwd
	return [dict create \
		DeltaG,Cen $CenDeltaG struct,Cen [lindex $out 3 0] \
		DeltaG,MEA $MEADeltaG struct,MEA [lindex $out 4 0] \
		DeltaG,MFE $MFEDeltaG struct,MFE [lindex $out 1 0] \
		mfefreq $MFEfreq]
}
